[LeetCode] Combination Sum IV 组合之和之四

题目

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

  • Example:
    nums = [1, 2, 3]
    target = 4
    The possible combination ways are:
    (1, 1, 1, 1)
    (1, 1, 2)
    (1, 2, 1)
    (1, 3)
    (2, 1, 1)
    (2, 2)
    (3, 1)

  • Note that different sequences are counted as different combinations.
    Therefore the output is 7.

  • Follow up:
    What if negative numbers are allowed in the given array?
    How does it change the problem?
    What limitation we need to add to the question to allow negative numbers?

  • Credits:
    Special thanks to @pbrother for adding this problem and creating all test cases.

    分析题目

    • 组合系列的第四道,本题要求我们求出和为target 的所有组合, 数字可以重复使用。
    • 同前三道组合数字不同,本题如果用递归,效率非常低。本题用dp来解。我们需要一个一维数组dp,其中dp[i]表示目标为i的解的个数,然后我们从1遍历到target,对于每一个数i,遍历nums数组,如果i >= num, dp[i] += dp[i - num]。
    • 举个例子,比如说对于[1,2,3] 4,这个例子,当我们在计算dp[3]的时候,3可以拆分为1+num,而num即为dp[2],3也可以拆分为2+num,此时num为dp[1],3同样可以拆为3+num,此时num为dp[0],我们把所有的情况加起来就是组成3的所有情况了.

    代码

class Solution {
    public int combinationSum4(int[] nums, int target) {
        int[] dp = new int[target + 1];
        Arrays.sort(nums);            //先给nums数组排个序
        dp[0] = 1;
        for(int i = 1 ; i <= target; i++){
            for (int num : nums) {
                if (i < num) break;   //从1遍历到target,对于i小于数组中的数字num时,直接break,因为后面的数更大
                dp[i] += dp[i - num];
            }
        }
        return dp[target];
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值